.\"	$NetBSD: fsirand.8,v 1.8 2005/06/14 14:02:12 peter Exp $
.\"
.\" Copyright (c) 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Christos Zoulas.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd November 16, 2001
.Dt FSIRAND 8
.Os
.Sh NAME
.Nm fsirand
.Nd install random inode generation numbers in a filesystem
.Sh SYNOPSIS
.Nm
.Op Fl F
.Op Fl p
.Op Fl x Ar constant
.Ar special
.Sh DESCRIPTION
.Nm
writes random inode generation numbers for all the inodes on device
.Ar special .
These random numbers make the NFS filehandles less predictable, increasing
security of exported filesystems.
.Pp
.Nm
should be run on a clean and unmounted filesystem.
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl F
Indicates that
.Ar special
is a file system image, rather than a device name.
.Ar special
will be accessed
.Sq as-is ,
without requiring that it is a raw character device and without
attempting to read a disklabel.
.It Fl p
Print the current inode generation numbers; the filesystem is not modified.
.It Fl x Ar constant
Exclusive-or the given constant with the random number used in the generation
process.
.El
.Pp
.Nm
exits zero on success, non-zero on failure.
.Pp
If
.Nm
receives a
.Dv SIGINFO
signal, statistics on the amount of work completed and estimated
completion time (in minutes:seconds) will be written to the standard
error output.
.Sh SEE ALSO
.Xr fsck_ffs 8 ,
.Xr newfs 8
